﻿using System;

using Microsoft.WindowsAzure.Subscriptions.Models;

namespace DemoGetSubscriptionsAndLogicApps
{
    public class SubscriptionWrapper : IComparable
    {
        #region Public Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="SubscriptionListOperationResponse.Subscription"/> class.
        /// </summary>
        /// <param name="subscription"></param>
        public SubscriptionWrapper(SubscriptionListOperationResponse.Subscription subscription)
        {
            this.SubscriptionId = subscription.SubscriptionId;
            this.SubscriptionName = subscription.SubscriptionName;
            this.SubscriptionStatus = subscription.SubscriptionStatus.ToString();
            this.AccountAdminLiveEmailId = subscription.AccountAdminLiveEmailId;
            this.ActiveDirectoryTenantId = subscription.ActiveDirectoryTenantId;
            this.Created = subscription.Created;
            this.ServiceAdminLiveEmailId = subscription.ServiceAdminLiveEmailId;
        }

        #endregion

        #region Public Instance Properties

        public string SubscriptionId { get; set; }
        public string SubscriptionName { get; set; }
        public string SubscriptionStatus { get; set; }
        public string AccountAdminLiveEmailId { get; set; }
        public string ActiveDirectoryTenantId { get; set; }
        public DateTime Created { get; set; }
        public string ServiceAdminLiveEmailId { get; set; }

        #endregion

        #region Public Instance Methods

        /// <summary>
        /// Returns a string representation of the instance.
        /// </summary>
        /// <returns>String representation of the instance</returns>
        public override string ToString()
        {
            return string.Format("{0} ({1})", this.SubscriptionName, this.SubscriptionStatus, this.SubscriptionId);
        }

        /// <summary>
        /// Compares this instance to the given instance.
        /// </summary>
        /// <param name="obj">Instance to compare to.</param>
        /// <returns></returns>
        public int CompareTo(object obj)
        {
            return SubscriptionName.CompareTo(obj);
        }

        #endregion
    }
}
